#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include "frasesDB.h"

static FILE *arquivo = NULL;
static char *frases = NULL;
static char *nomearq = NULL;

static int getSize ()
{
  struct stat arqstat;

  stat (nomearq, &arqstat);

  return arqstat.st_size;
}


static void openFrases (char *idioma)
{
  if (! arquivo) {
    /* Gera nome do arquivo de saida = ARQ_FRASES + idioma */
    nomearq = strdup(ARQ_FRASES);
    nomearq = realloc (nomearq, strlen(nomearq) + strlen(idioma) + 1);
    nomearq = strcat (nomearq, idioma);
   
    /* Abre arquivo */
    arquivo = fopen (nomearq, LEITURA);
  }
}


static void readFrases ()
{
  int tam;

  tam = getSize();

  if (! frases)
    frases = (char *) calloc (tam + 1, sizeof (char));

  if (arquivo &&  strlen (frases) == 0)
    fread (frases, sizeof(char), tam, arquivo);
}

void fechar()
{
  fclose (arquivo);
  free(nomearq);
  arquivo = NULL;
  frases = NULL;
  nomearq = NULL;
}    
      
char *leFrase (char *tipo, char *idioma)
{
  char *inicio,
       *fim,
       *label,
       *result;

  openFrases (idioma);
  readFrases ();

  label = (char *) calloc (strlen(tipo) + strlen(" = ") + 1,
			   sizeof(char));
  strcpy (label, tipo);
  strcat (label, " = ");

  if (frases) {
    inicio = strstr (frases, label);
    inicio += strlen (label);

    fim = strstr (inicio, " = ");
    while (*fim-- != '\n');

    result = (char *) calloc (fim - inicio + 2, sizeof (char));
    strncpy (result, inicio, fim - inicio + 1);

    return (result);

  }
}

